/*
 *	Log part of pasmal
 *
 */

#include "log.h"
#include <syslog.h>
#include <stdarg.h>
#include <errno.h>

#define BUF_SIZE 2048

void
msglog (int priority, char *logfile, char *format, ...)
{
  char buf[(BUF_SIZE + 1)];
  FILE *fp;
  va_list ap;


  va_start (ap, format);
  (void) vsnprintf (buf, BUF_SIZE, format, ap);
  va_end (ap);


  setlogmask (LOG_UPTO (LOG_NOTICE));
  openlog ("pasmal", LOG_CONS | LOG_PID | LOG_NDELAY, LOG_LOCAL1);
  syslog (priority, "%s", buf);
  closelog ();

  if (logfile && ((fp = fopen (logfile, "a")) != NULL))
    {
      struct tm *lt;
      time_t tt;

      tt = time (0);
      lt = localtime (&tt);

      fprintf (fp, "%02d-%02d %02d:%02d:%02d: %s (%d)\n", (lt->tm_mon + 1),
	       lt->tm_mday, lt->tm_hour, lt->tm_min, lt->tm_sec, buf,errno);
      fclose (fp);
    }
}

void
packetcountlog (char *logfile, int style)
{
  FILE *fp;
  struct tm *lt;
  time_t tt;
  int year;
  tt = time (0);
  lt = localtime (&tt);

  year = lt->tm_year;
  if (year >= 100 && year < 200)
    year %= 100;
  if (year < 100)
    if (year > 68)
      year += 1900;
    else
      year += 2000;

  if (style == 0)
    count++;
  else if(style == 1)
    usefullcount++;
  else
    processedcount++;

  if (oldh == -1)
    {
      count = 1;
      usefullcount = 0;
      processedcount = 0;
      oldh = (int) lt->tm_hour;
    }
  else if ((int) lt->tm_hour != oldh)
    {
      oldh = (int) lt->tm_hour;

      if (logfile && ((fp = fopen (logfile, "a")) != NULL))
	{

	  fprintf (fp, "%04d-%02d-%02d,%02d:%02d:%02d,%.0f,%.0f,%.0f\n", (year),
		   (lt->tm_mon + 1), lt->tm_mday, lt->tm_hour, lt->tm_min,
		   lt->tm_sec, count, processedcount, usefullcount);
	  fclose (fp);

	  count = 0;
          usefullcount = 0;
          processedcount = 0;

	}
    }

}

void
error (char *err, char *logfile)
{
  msglog (LOG_ERR, logfile, "%s", err);
  perror("error");
}
