/*
 * pasmal - main program
 *	
 *
 */

#include "pasmal.h"
#include "generator.h"
//#define DEBUG


void
current_version (char *progname)
{
  printf ("%s ver %s by %s (rel on %s).\n", progname, VERSION, AUTHORS,
	  REL_DATE);
  msglog (LOG_INFO, NULL, "%s ver %s starting", progname, VERSION);
}


void
parse_config_file (char *cfg_file)
{
  int a;
  char *str = malloc (255);
  char *maxload_str = malloc (255);
  FILE *fp;

  servip = malloc (255);
  dev_name = malloc (255);
  maxload_str = malloc (255);
  errorlog = malloc (255);
  seqlog = malloc (255);
  packetlog = malloc (255);

  if ((fp = fopen (cfg_file, "r")) == NULL)
    {
      perror (__cfg_err__);
      (void) error ("Couldn't find config file!", DEFAULT_ERRORLOG);
      exit (1);
    }

  while (!feof (fp))
    {

      bzero (str, 255);
      fgets (str, 254, fp);

      if (strncmp (str, "DIE", 3) == 0)
	{
	  printf ("You did edit /etc/pasmal.conf, didn't you?\n");
	  exit (1);
	}
      if (strncmp (str, "IP", 2) == 0)
	{
	  bzero (servip, 255);
	  a = 2;
	  while (str[++a] != ';')
	    servip[a - 3] = str[a];
#ifdef DEBUG
	  printf ("IP=%s;\n", servip);
#endif
	}

      if (strncmp (str, "LISTENER", 8) == 0)
	{
	  if (str[9] == 'U' || str[9] == 'T')
	    {
	      if (str[9] == 'U')
		listenerp = 0;
	      else if (str[9] == 'T')
		listenerp = 1;
	      listenerd = atoi (&str[13]);
#ifdef DEBUG
	      printf ("LISTENERP=%d;\n", listenerp);
	      printf ("LISTENERD=%d;\n", listenerd);
#endif

	    }
	}
      if (strncmp (str, "LISTENERT", 9) == 0)
	{
	  listenert = atoi (&str[10]);
#ifdef DEBUG
	  printf ("LISTENERT=%d;\n", listenert);
#endif
	}
      if (strncmp (str, "DEV", 3) == 0)
	{
	  bzero (dev_name, 255);
	  a = 3;
	  while (str[++a] != ';')
	    dev_name[a - 4] = str[a];
#ifdef DEBUG
	  printf ("DEV=%s;\n", dev_name);
#endif
	}
      if (strncmp (str, "MAXLOAD", 7) == 0)
	{
	  a = 3;
	  while (str[++a] != ';')
	    maxload_str[a - 8] = str[a];
	  maxload = atoi (maxload_str);
#ifdef DEBUG
	  printf ("MAXLOAD=%d;\n", maxload);
#endif
	}
      if (strncmp (str, "onerror", 7) == 0)
	{
	  str[9] = 0;
	  onerror = atoi (&str[8]);
	  if (onerror > 1 || onerror < 0)
	    {
	      perror (__cfg_err__);
	      exit (1);
	    }
	}
      if (strncmp (str, "log", 3) == 0)
	{
	  str[5] = 0;
	  log = atoi (&str[4]);
	  if (log > 1 || log < 0)
	    {
	      perror (__cfg_err__);
	      exit (1);
	    }
	}
      if (strncmp (str, "errorlog", 8) == 0)
	{
	  bzero (errorlog, 255);
	  a = 8;
	  while (str[++a] != ';')
	    errorlog[a - 9] = str[a];
	}
      if (strncmp (str, "packetlog", 9) == 0)
	{
	  bzero (packetlog, 255);
	  a = 9;
	  while (str[++a] != ';')
	    packetlog[a - 10] = str[a];
	}
      if (strncmp (str, "seqlog", 6) == 0)
	{
	  bzero (seqlog, 255);
	  a = 6;
	  while (str[++a] != ';')
	    seqlog[a - 7] = str[a];
	}
      if (strncmp (str, "seq {", 5) == 0)
	{
	  fp = add_new_sequence (fp);
	}
    }

  fclose (fp);

  free (str);
  free (maxload_str);

}


FILE *
add_new_sequence (FILE * fp)
{
  char *str = malloc (255);
  int a = 0;

  if (first == NULL)
    {
      if (strlen (errorlog) < 1)
	strncpy (errorlog, DEFAULT_ERRORLOG, strlen (DEFAULT_ERRORLOG));
      first = (struct seqf *) malloc (sizeof (struct seqf));
      first->count = 0;
      first->final = 0;
      temp = first;
      use = first;
      first->next = NULL;
    }
  else
    {
      use->next = (struct seqf *) malloc (sizeof (struct seqf));
      use = use->next;
      use->next = NULL;
      use->count = 0;
      use->final = 0;
      use->act = 0;
    }

  do
    {
      bzero (str, 255);
      fgets (str, 255, fp);

      if (strncmp (str, "NAME=", 5) == 0)
	{
	  a = 5;
	  use->name = malloc (255);
	  while (str[++a] != '"' && a < 254)
	    use->name[a - 6] = str[a];
	}

      if (strncmp (str, "TCP PORT ", 9) == 0)
	{
	  use->seq =
	    (int *) realloc (use->seq, sizeof (int) * (use->count + 1));
	  use->seq[use->count] = atoi (&str[9]);
	  use->count++;
	}
      if (strncmp (str, "UDP PORT ", 9) == 0)
	{
	  use->seq =
	    (int *) realloc (use->seq, sizeof (int) * (use->count + 1));
	  use->seq[use->count] = -(atoi (&str[9]));
	  use->count++;
	}
      if (strncmp (str, "ICMP", 4) == 0)
	{
	  use->seq =
	    (int *) realloc (use->seq, sizeof (int) * (use->count + 1));
	  use->seq[use->count] = -777;
	  use->count++;
	}
      if (str[0] == '[')
	{
	  if (add_action (str) < 0)
	    {

	      if (onerror == 1)
		{
		  (void) error (__cfg_err__, errorlog);
		  exit (1);
		}

	    }
	}

    }
  while (strncmp (str, "};", 2) != 0);

  free (str);
  return fp;
}


int
add_action (char *action)
{
  int a = 0;

  use->action =
    (char **) realloc (use->action, sizeof (char **) * (use->act + 1));
  use->action[use->act] = malloc (255);
  bzero (use->action[use->act], 255);

  while (action[++a] != ']' && a < 254)
    use->action[use->act][a - 1] = action[a];

  use->act++;

}


int
main (int argc, char **argv)
{
  FILE *fp;

  (void) current_version (argv[0]);

  fp = fopen (GENERATION_FILE, "r");

  if (fp == NULL)
    generation ();
  else
    fclose (fp);

  if (argc > 1)
    {
      if (strncmp (argv[1], "-v", 2) == 0)
	return -1;
      if (strncmp (argv[1], "-r", 2) == 0)
	system ("pasmal.check refresh");

      if (strncmp (argv[1], "-c", 2) == 0)
	{
	  if (argc < 3)
	    {
	      perror (__cfg_err__);
	      return -1;
	    }
	  else
	    {
	      maxload = -1;
	      parse_config_file (argv[2]);
	      if (strlen (packetlog) == 0)
		sprintf (packetlog, "/var/log/pasmal-packetlog.csv");

	      if ((fp = fopen (PIDFILE, "w")) == NULL)
		{
		  perror (__pid_err__);
		  if (onerror == 1)
		    (void) error ("Error creating PID file !", errorlog);
		  exit (1);
		}

	      fprintf (fp, "%d\n", getpid ());

	      fclose (fp);

	      (void) sniffer (errorlog, seqlog, onerror, log, first);


	    }

	}
    }
  else
    {
      parse_config_file (DEFAULT_CFG);

      if (strlen (packetlog) == 0)
	sprintf (packetlog, "/var/log/pasmal-packetlog.csv");

      if ((fp = fopen (PIDFILE, "w")) == NULL)
	{
	  perror (__pid_err__);
	  if (onerror == 1)
	    (void) error ("Error creating PID file !", errorlog);
	  exit (1);
	}

      fprintf (fp, "%d\n", getpid ());

      fclose (fp);

      (void) sniffer (packetlog, errorlog, seqlog, onerror, log, first,
		      servip, dev_name, maxload);
    }

}
