/*
 *      pasmal client program (must be root to run => ICMP,UDP)
 *	thanks to "raw easy" by our friends from .cz
 */

#include "client.h"
#define SKEY "/etc/smokescreen_key"
#define IPPWD "/var/log/"

int
current_version (char *progname)
{
  printf ("%s ver %s by %s (rel on %s).\n", progname, VERSION, AUTHORS,
	  REL_DATE);
  return 1;
}


void
chk (char *arg)
{

  if (strlen (arg) > 32)
    exit (1);

}


// dev_name is a parameter from pasmal.client, passed for the interface name
// srci is thje ip address passed from pasmal.client to receive the smoke screen frame sequence

int
sniffer (char *dev_name, char *srci)
{

  unsigned char *buffer;
  char *dip;
  char *sip;

  unsigned short sport, dport;
  int sock, buflen, fromlen, tstc = 0;
  struct sockaddr_ll sll, from;
  struct packet_mreq promisc;
  struct ifreq interface;

  struct in_addr myip;
  struct in_addr src, dst;
  struct icmphdr *icmp;
  struct tcphdr *tcp;
  struct udphdr *udp;
  struct iphdr *incoming_ip;

  buffer = (unsigned char *) malloc (BIGBUFFER);
  memset (&interface, 0, sizeof (interface));
  memset (&sll, 0, sizeof (sll));
  memset (&promisc, 0, sizeof (promisc));

  dip = (char *) malloc (255);

  if ((sock = socket (PF_PACKET, SOCK_DGRAM, htons (3))) == -1)
    {
      return -1;
    }

  strncpy (interface.ifr_name, dev_name, sizeof (interface.ifr_name));

  if (ioctl (sock, SIOCGIFINDEX, &interface) == -1)
    {
      return (-1);
    }


  if (ioctl (sock, SIOCGIFADDR, &interface) == -1)
    {
      return (-1);
    }

  sll.sll_family = AF_PACKET;
  sll.sll_ifindex = interface.ifr_ifindex;
  sll.sll_protocol = htons (3);

  memcpy (&myip,
	  &((struct sockaddr_in *) &interface.ifr_ifru.ifru_addr)->sin_addr,
	  sizeof (struct sockaddr_in));

  if (bind (sock, (struct sockaddr *) &sll, sizeof (sll)) == -1)
    {
      return -1;
    }

  promisc.mr_ifindex = interface.ifr_ifindex;
  promisc.mr_type = PACKET_MR_PROMISC;

  if (setsockopt
      (sock, SOL_PACKET, PACKET_ADD_MEMBERSHIP, &promisc,
       sizeof (promisc)) == -1)
    {
      return -1;
    }


  while (tstc == 0)
    {

      fromlen = sizeof (from);
      if ((buflen = recvfrom (sock, buffer, BIGBUFFER, 0,
			      (struct sockaddr *) &from, &fromlen)) == -1)
	{
	  return -1;
	}

      if ((strcmp (dev_name, "lo") != 0
	   && from.sll_pkttype != PACKET_OUTGOING)
	  && from.sll_family == AF_PACKET
	  || ntohs (from.sll_protocol) == 0x800)
	{

	  incoming_ip = (struct iphdr *) buffer;

	  src.s_addr = incoming_ip->saddr;
	  dst.s_addr = incoming_ip->daddr;

	  if (incoming_ip->protocol == SOL_TCP)
	    {

	      tcp =
		(struct tcphdr *) ((void *) incoming_ip +
				   sizeof (struct iphdr));

	      sport = htons (tcp->source);
	      dport = htons (tcp->dest);

	      bzero (dip, 255);
	      strncpy (dip, inet_ntoa (dst), strlen (inet_ntoa (dst)));

	      if (strncmp (dip, inet_ntoa (myip), strlen (inet_ntoa (myip)))
		  == 0)
		{

		  if (strncmp
		      (srci, inet_ntoa (src), strlen (inet_ntoa (src))) == 0)
		    {

		      tstc = 1;
		      return dport;

		    }

		}

	    }

	}

    }
}


unsigned short
checksum (unsigned short *addr, int len)
{
  int reste, somme;
  unsigned short *where, reponse;

  somme = 0;
  reponse = somme;

  reste = len;
  where = addr;

  while (reste > 1)
    {
      somme += *where = *where + 1;
      reste = reste - 2;
    }

  if (reste)
    {
      *(unsigned char *) (&reponse) = *(unsigned char *) where;
      somme = somme + reponse;
    }

  somme = (somme >> 0x10) + (somme & 0xFFFF);
  somme = somme + (somme >> 0x10);
  return (~somme);
}

void
send_udp (char *dst, unsigned short int port)
{
  int sockfd;
  char *junk = malloc (255);

  struct sockaddr_in client_addr, server_addr;

  usleep (50);

  bzero ((void *) &server_addr, sizeof (server_addr));
  bzero ((void *) &client_addr, sizeof (client_addr));

  server_addr.sin_family = AF_INET;
  server_addr.sin_addr.s_addr = inet_addr (dst);
  server_addr.sin_port = htons (port);

  client_addr.sin_family = AF_INET;
  client_addr.sin_addr.s_addr = htons (INADDR_ANY);
  client_addr.sin_port = htons (0);

  if ((sockfd = socket (AF_INET, SOCK_DGRAM, 0)) < 0)
    {
      perror (__sock_err__);
      exit (1);
    }

  if (bind (sockfd, (struct sockaddr *) &client_addr, sizeof (client_addr)) <
      0)
    {
      perror (__bind_err__);
      exit (1);
    }

  junk[0] = (char) rand () % 255;
  sendto (sockfd, junk, 1, 0, (struct sockaddr *) &server_addr,
	  sizeof (server_addr));

  free (junk);

  close (sockfd);
}


void
send_tcp (char *dst, unsigned short int port)
{
  int sockfd;
  char *junk;
  struct sockaddr_in client_addr;

  usleep (50);

  junk = malloc (2);
  bzero ((void *) &client_addr, sizeof (client_addr));

  client_addr.sin_family = AF_INET;
  client_addr.sin_addr.s_addr = inet_addr (dst);
  client_addr.sin_port = htons (port);

  if ((sockfd = socket (AF_INET, SOCK_STREAM, 0)) < 0)
    {
      perror (__sock_err__);
      exit (1);
    }

  connect (sockfd, (struct sockaddr *) &client_addr, sizeof (client_addr));

  close (sockfd);
}

void
send_icmp (char *dst)
{
  struct ip ip;
  struct icmp icmp;
  const int on = 1;
  int sockfd;
  struct sockaddr_in sin;
  u_char *buffer;

  usleep (50);

  buffer = (u_char *) malloc (60);
  bzero ((void *) &ip, sizeof (ip));
  bzero ((void *) &icmp, sizeof (icmp));
  bzero ((void *) &sin, sizeof (sin));
  memset (&sin, 0, sizeof (sin));

  sin.sin_family = AF_INET;
  sin.sin_addr.s_addr = inet_addr (dst);

  ip.ip_hl = 0x5;
  ip.ip_v = 0x4;
  ip.ip_len = 60;
  ip.ip_id = htons (1000 + rand () % 1000);
  ip.ip_ttl = 64;
  ip.ip_p = IPPROTO_ICMP;
  ip.ip_src.s_addr = htons (INADDR_ANY);
  ip.ip_dst.s_addr = inet_addr (dst);
  ip.ip_sum = checksum ((unsigned short *) &ip, sizeof (ip));

  memcpy (buffer, &ip, sizeof (ip));

  icmp.icmp_type = ICMP_ECHO;
  icmp.icmp_id = rand () % 1000;

  icmp.icmp_cksum = checksum ((unsigned short *) &icmp, 8);

  memcpy (buffer + 20, &icmp, 8);

  if ((sockfd = socket (AF_INET, SOCK_RAW, IPPROTO_RAW)) < 0)
    {
      perror (__sock_err__);
      exit (1);
    }

  if (setsockopt (sockfd, IPPROTO_IP, IP_HDRINCL, &on, sizeof (on)) < 0)
    {
      perror (__setsockopt_err__);
      exit (1);
    }

  sendto (sockfd, buffer, 60, 0, (struct sockaddr *) &sin,
	  sizeof (struct sockaddr));

}

int
smokescreen (int argc, char **argv, int ptr, char *dst)
{
  int ptr_smk = 0, tst_smk = 0;
  char smk[10];
  FILE *fp;
  ptr_smk = sniffer (argv[ptr + 1], dst);

  if (ptr_smk == -1)
    {
      perror ("sniffer");
      exit (1);
    }
  ptr += 2;
  do
    {
      while (tst_smk == 0)
	{

// Se mettre sur le fichier smoke screen
	  if (rand () % 100 < 85)
	    {

	      fp = fopen (SKEY, "r");
	      if (fp == NULL)
		{
		  perror ("skey");
		  exit (1);
		}
	      bzero (smk, 10);
	      fseek (fp, 7L * ptr_smk, SEEK_SET);
	      ptr_smk++;
	      fread (smk, 6, 1, fp);


	      if (smk[0] == 'T')
		{
		  printf ("*** Sending TCP:%d\n", atoi (&smk[1]));
		  send_tcp (dst, atoi (&smk[1]));
		}
	      else if (smk[0] == 'U')
		{
		  printf ("*** Sending UDP:%d\n", atoi (&smk[1]));
		  send_udp (dst, atoi (&smk[1]));
		}
	      else if (smk[0] == 'I')
		{
		  printf ("*** Sending ICMP\n");
		  send_icmp (dst);
		}

	      fclose (fp);
	    }
	  else
	    {
	      if (ptr < argc)
		{

		  printf ("*** Sending %s\n", argv[ptr]);
		  if (strncmp (argv[ptr], "ICMP", 4) == 0)
		    {
		      send_icmp (dst);
		    }
		  else if (strncmp (argv[ptr], "TCP:", 4) == 0)
		    {
		      send_tcp (dst, atoi (&argv[ptr][4]));
		    }
		  else if (strncmp (argv[ptr], "UDP:", 4) == 0)
		    {
		      send_udp (dst, atoi (&argv[ptr][4]));
		    }
		  else
		    {
		      printf ("*** Unreconized sequence found : %s\n",
			      argv[ptr]);
		      exit (-1);
		    }
		  ptr++;
		}
	      else
		tst_smk = 1;

	    }

	}
    }
  while (rand () % 200 < 10);

}

void
usage (char *progname)
{
  printf
    ("Usage : %s IP seq1 seq2 seq3 ...\nie:%s 127.0.0.1 TCP:1070 ICMP TCP:1023 UDP:23 TCP:13 ICMP\n",
     progname, progname);
}

int
main (int argc, char **argv)
{
  int i, smk_rnd;
  char *dst, *smkpwd;
  time_t t;
  FILE *fp;

  smkpwd = malloc (255);
  bzero (smkpwd, 255);
  dst = malloc (32);
  bzero (dst, 32);

  (void) current_version (argv[0]);

  if (argc < 3)
    usage (argv[0]);
  else
    {
      chk (argv[1]);
      strncpy (dst, argv[1], strlen (argv[1]));
      for (i = 2; i < argc; i++)
	{
	  chk (argv[i]);
	  printf ("*** Sequencing %4d for destination %s : %s\n", (i - 1),
		  dst, argv[i]);
	  if (strncmp (argv[i], "ACT", 3) == 0)
	    {
	      smokescreen (argc, argv, i, dst);
	      i = argc;
	    }
	  else if (strncmp (argv[i], "SMK", 3) == 0)
	    {
	      sleep (1);
	      srand ((unsigned) time (&t));
	      sprintf (smkpwd, "%spasmal-smk-%s", IPPWD, dst);
	      smk_rnd = rand () % 60000;
	      fp = fopen (smkpwd, "w");
	      if (fp == NULL)
		{
		  perror ("smkpwd");
		  exit (1);
		}
	      fprintf (fp, "%d", smk_rnd);
	      fclose (fp);
	      send_tcp (dst, smk_rnd);
	    }
	  else if (strncmp (argv[i], "ICMP", 4) == 0)
	    {
	      send_icmp (dst);
	    }
	  else if (strncmp (argv[i], "TCP:", 4) == 0)
	    {
	      send_tcp (dst, atoi (&argv[i][4]));
	    }
	  else if (strncmp (argv[i], "UDP:", 4) == 0)
	    {
	      send_udp (dst, atoi (&argv[i][4]));
	    }
	  else
	    {
	      printf ("*** Unreconized sequence found : %s\n", argv[i]);
	      exit (-1);
	    }

	}
    }
}
