
/*
 *	pasmal.log = check log carefully...
 *
 */

#include "pasmal.log.h"
#include "errors.h"

int
usage (char *progname)
{

  printf
    ("%s [-c configfile] <arg>\n<arg> can be a module name (ie inetd)\n<arg> can be a date loglike dd-mm\n<arg> can be an ip address (ie 1.2.3.4)\n",
     progname);
  return -1;
}

char *errorlog;
char *seqlog;

void
parse_config_file (char *cfg_file)
{
  int a;
  char *str = malloc (255);
  FILE *fp;

  errorlog = malloc (255);
  seqlog = malloc (255);

  if ((fp = fopen (cfg_file, "r")) == NULL)
    {
      perror (__cfg_err__);
      exit (1);
    }

  while (!feof (fp))
    {

      bzero (str, 255);
      fgets (str, 255, fp);

      if (strncmp (str, "DIE", 3) == 0)
	{
	  printf ("Did you edit /etc/pasmal.conf, didnt you?\n");
	  exit (1);
	}

      if (strncmp (str, "errorlog", 8) == 0)
	{
	  bzero (errorlog, 255);
	  a = 8;
	  while (str[++a] != ';')
	    errorlog[a - 9] = str[a];
	}

      if (strncmp (str, "seqlog", 6) == 0)
	{
	  bzero (seqlog, 255);
	  a = 6;
	  while (str[++a] != ';')
	    seqlog[a - 7] = str[a];
	}
    }

  fclose (fp);

  free (str);

}


int
main (int argc, char **argv)
{
  FILE *fp;
  char *tofind;
  char *str = malloc (255);



  printf ("pasmal.log %s %s\n", VERSION, AUTHORS);

  if (argc < 2)
    return (usage (argv[0]));
  if (strlen (argv[1]) > 254)
    argv[1][254] = 0;

  if (strncmp (argv[1], "-c", 2) == 0)
    {
      if (argc < 4)
	{
	  return (usage (argv[0]));
	}
      else
	{
	  if (strlen (argv[2]) > 254)
	    argv[2][254] = 0;
	  if (strlen (argv[3]) > 254)
	    argv[3][254] = 0;
	  tofind = argv[3];
	  parse_config_file (argv[2]);

	}

    }
  else
    {
      parse_config_file ("/etc/pasmal.conf");
      tofind = argv[1];
    }



  parse_config_file ("/etc/pasmal.conf");

  fp = fopen (seqlog, "r");

  if (fp == NULL)
    {
      perror (__logc_err__);
      (void) error ("Couldn't find log file!", DEFAULT_ERRORLOG);
      return -1;
    }

  while (!feof (fp))
    {
      bzero (str, 255);
      fgets (str, 255, fp);
      if (strstr (str, tofind) != NULL)
	printf ("%s", str);

    }

  fclose (fp);

  fp = fopen (errorlog, "r");

  if (fp == NULL)
    {
      return -1;
    }

  while (!feof (fp))
    {
      bzero (str, 255);
      fgets (str, 255, fp);
      if (strstr (str, tofind) != NULL)
	printf ("%s", str);

    }

  fclose (fp);
  free (str);

  return (0);
}
